#!/usr/bin/python
import time, os, LGI;
import math, sys;

#Create Atomic POSCAR file
def create_poscar_file_AT(location, Z, r):
    #CREATE A POSCAR FILE
    #input: a3D [A](double) -- Supercell [int] -- layers [int] -- vacuum distance [A](int)  -- fix -- layerpositions [] [] []... -- Atom/Molecule -- u -- v -- t -- p -- Z -- r 
    #string = "./pes 3.63999 3 6 20 fix 0.00000 2.10154 4.19923 6.30387 8.40225 10.49567 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #B86SRP68
    string = "./pes 3.6560 3 6 20 fix 0.00000 2.11079 4.21729 6.33030 8.43675 10.53977 Atom %s %1.5f %1.5f > POSCAR" %(location, Z, r); #PBEa57
    print "string= ", string; 
    os.system(string) #this is the commandline, executing the command in varibale string --> creating a POSCAR file using the desirec input
    print 

# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------
#Create Molecule POSCAR file
def create_poscar_file(location, Z, r):
    #CREATE A POSCAR FILE
    #input: a3D [A](double) -- Supercell [int] -- layers [int] -- vacuum distance [A](int)  -- fix -- layerpositions [] [] []... -- Atom/Molecule -- u -- v -- t -- p -- Z -- r 
    #string = "./pes 3.6287 3 6 20 fix 0.00000 2.09503 4.18699 6.28615 8.37945 10.46748 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r);  #SRPsol75-DF2 layer positions
    #string = "./pes 3.6349 3 6 20 fix 0.00000 2.09861 4.19334 6.29482 8.39086 10.48173 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #SRPsol70-DF2 layer positions
    #string = "./pes 3.64427 3 6 20 fix 0.00000 2.10402 4.20374 6.31019 8.41056 10.50654 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #SRPsol62.65-DF2 Layer positions
    #string = "./pes 3.63999 3 6 20 fix 0.00000 2.10154 4.19923 6.30387 8.40225 10.49567 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #B86SRP68
    #string = "./pes 3.6376 3 6 20 fix 0.00000 2.10014 4.19621 6.29898 8.39546 10.48732 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #B86SRP70
    string = "./pes 3.6560 3 6 20 fix 0.00000 2.11079 4.21729 6.33030 8.43675 10.53977 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #PBEa57-DF2
    print "string= ", string; 
    os.system(string) #this is the commandline, executing the command in varibale string --> creating a POSCAR file using the desirec input
    print 

# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------

#check and download finished jobs
def check_finished(CURRENT_DIRECTORY, Client, functional ):
    print "Entering check_finished function...."
    print "Current date & time " + time.strftime("%c")

    LIST_FINISHED  = Client.GetJobList( Application = "vasp535", State = "finished", Limit=1024);
    N_FINISHED = LIST_FINISHED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];

    if (N_FINISHED > 1):
      #for JOB_FINISHED in LIST_FINISHED[ 'LGI' ][ 'response' ][ 'job' ][ : ][ 'job' ]:
      for job_num in range(0, N_FINISHED):
 
        #GET THE JOB ID  
        JOB_FINISHED   = LIST_FINISHED[ 'LGI' ][ 'response' ][ 'job' ][ job_num ][ 'job' ];                   
        job_id         = JOB_FINISHED[ 'job_id' ]
        job_specifics  = JOB_FINISHED[ 'job_specifics' ]
        project        = job_specifics[ 'project' ]

        if ( project == "PES" ):
          repository_url = job_specifics[ 'repository_url' ] 
          folder         = job_specifics[ 'foldername' ]
          func           = job_specifics[ 'functional' ] 

          #only do something if the job is from batch 
          if ( func == functional ):
            #TRANSFER FILES
            #CHANGE THE DIRECTORY  
            os.chdir("LGI_OUTPUT");
            #MAKE A NEW DIRECTORY
            os.mkdir("%s" %(folder));
            os.chdir("%s" %(folder));
            #TRANFER FILE
            #Client.LGI_filetransfer download repository_url OUTCAR OSZICAR POSCAR vasprun.xml ;
            print "downloading: ", repository_url
            FileTransferClient = LGI.LGI_Client( URL = repository_url );
            FileTransferClient.DownLoadFiles( [ "OUTCAR", "OSZICAR", "CHGCAR", "POSCAR", "vasprun.xml" ], "./" );
            print "deleting job nr ", job_id
            Client.DeleteJob( job_id );
            del FileTransferClient;
            #GO BACK TO WORKING DIRECTORY
            os.chdir(CURRENT_DIRECTORY);

# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------
def check_Q(MAX_NUM_RUNNING_JOB, CURRENT_DIRECTORY, Client, functional):
	print "entering check_Q function..."
        print "Current date & time " + time.strftime("%c")


        # FIRST: ASK LGI HOW MANY JOBS ARE RUNNING
        #        AND HOW MANY JOBS ARE QUEUED
        # IF THE NUMBER OF QUEUED JOBS IS LARGER THEN MAX_NUM_QUEUED_JOB
        # THEN FALL ASLEEP, OTHERWISE CONTINUE WITH SUBMITTING JOBS
        CONTINUE_VAR = 1 ;
        while CONTINUE_VAR == 1 :
        	LIST_QUEUED  = Client.GetJobList( State = "queued", Limit=0 );
	        LIST_RUNNING = Client.GetJobList( State = "running", Limit=0);
        	N_QUEUED     = LIST_QUEUED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ] ;
	        N_RUNNING    = LIST_RUNNING[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
        	print "queued:", N_QUEUED, "running: ", N_RUNNING
	        #IF THE NUMBER OF QUEUED JOBS IS SMALLER THAN 
        	#if (N_QUEUED < MAX_NUM_QUEUED_JOB and N_RUNNING < MAX_NUM_RUNNING_JOB):
	        if (N_QUEUED + N_RUNNING < MAX_NUM_RUNNING_JOB):
        		CONTINUE_VAR = 0;
	        else:   
			check_finished(CURRENT_DIRECTORY, Client, functional )
			print "Going to sleep...."     
        		time.sleep(600);  

        #IF THERE ARE ABORTED JOBS THEN DELETE THEM
        LIST_ABORTED  = Client.GetJobList( Application = "vasp535", State = "aborted", Limit=1024);
        N_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
        if N_ABORTED > 1:
        	for job_num in range(0, N_ABORTED):
          		JOB_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'job' ][ job_num ][ 'job' ];
          		job_id = JOB_ABORTED[ 'job_id' ];
          		job_specifics = JOB_ABORTED[ 'job_specifics' ];
          		repository_url = job_specifics[ 'repository_url' ] ;
          		Client.DeleteJob( job_id );

# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------

#MAIN program
#----------------------------------------------------------------------------------------------------------
#   
#  4 different parts of the PES need to be done
#       1. EXTRAPOL
#       2. GASPHASE
#       3. ATOM     3D PES
#       4. MOLECULE 6D PED
#

#ASK FOR THE CURRENT DIRECTORY
CURRENT_DIRECTORY = os.getcwd()

project    = "PES"
functional = "PBEa57-DF2"
Queue      = "long"
maxwalltime= "24:00:00"
maxram     = "60"
Client     = LGI.LGI_Client();

MAX_NUM_RUNNING_JOB  = 1000;

#these are the 29 location used for a FCC(111) CRP PES 
#  These u, v, theta, phi coordinates correspond to a 120degree unitcell.
#  --> for GASPHASE & EXTRAPOL location = 1 --> u=0 v=0 theta=90 phi=0
location   = [ "0 0 0 0", "0 0 90 0", "0 0 90 30", "0.5 0 0 0", "0.5 0 90 0", "0.5 0 90 60", "0.5 0 90 90", "0.66666666 0.33333333 0 0", "0.66666666 0.33333333 45 30", "0.66666666 0.33333333 45 210", "0.66666666 0.33333333 90 0", "0.66666666 0.33333333 90 30", "0.33333333 0.16666666 0 0", "0.33333333 0.16666666 45 30", "0.33333333 0.16666666 45 120", "0.33333333 0.16666666 45 210", "0.33333333 0.16666666 90 30", "0.33333333 0.16666666 90 120", "0.33333333 -0.33333333 0 0", "0.33333333 -0.33333333 45 150", "0.33333333 -0.33333333 45 330", "0.33333333 -0.33333333 90 0", "0.33333333 -0.33333333 90 330", "0.16666666 -0.16666666 0 0", "0.16666666 -0.16666666 45 150", "0.16666666 -0.16666666 45 240", "0.16666666 -0.16666666 45 330", "0.16666666 -0.16666666 90 240", "0.16666666 -0.16666666 90 330" ];
#10 atomic locations
locationAT = [ "0.0 0.0 0.0 0.0", "0.5 0.0 0.0 0.0", "0.66666666 0.33333333 0.0 0.0", "0.33333333 0.16666666 0.0 0.0", "0.5 0.16666666 0.0 0.0", "0.16666666 0.0 0.0 0.0", "0.33333333 0.0 0.0 0.0", "0.16666666 -0.16666666 0.0 0.0", "0.33333333 -0.16666666 0.0 0.0", "0.33333333 -0.33333333 0.0 0.0" ]

#Z values for the 6D molecular potential 
NZ6D        = 21;
Z6D         = [ 0.25, 1.0, 1.25, 1.50, 1.75, 2.0, 2.25, 2.50, 2.75, 3.0, 3.25, 3.50, 3.75, 4.0, 4.25, 4.5, 4.75, 5.0, 5.5, 6.0, 7.0 ];

#Z values for the extrapol calculations
NZextrapol  = 22;
Zextrapol   = [ 2.25, 2.50, 2.75, 3.0, 3.25, 3.50, 3.75, 4.0, 4.25, 4.5, 4.75, 5.0, 5.5, 6.0, 6.5, 7.0, 7.5, 8.0, 8.5, 9.0, 9.5, 10.0 ];

#Z values for the atomic PES at TOP site
NZATTOP      = 322
ZATTOP       = [ -2.0, -1.975, -1.95, -1.925, -1.9, -1.875, -1.85, -1.825, -1.8, -1.775, -1.75, -1.725, -1.7, -1.675, -1.65, -1.625, -1.6, -1.575, -1.55, -1.525, -1.5, -1.475, -1.45, -1.425, -1.4, -1.375, -1.35, -1.325, -1.3, -1.275, -1.25, -1.225, -1.2, -1.175, -1.15, -1.125, -1.1, -1.075, -1.05, -1.025, -1.0, -0.975, -0.95, -0.925, -0.9, -0.875, -0.85, -0.825, -0.8, -0.775, -0.75, -0.725, -0.7, -0.675, -0.65, -0.625, -0.6, -0.575, -0.55, -0.525, -0.5, -0.475, -0.45, -0.425, -0.4, -0.375,-0.35,-0.325,-0.3,-0.275,-0.25,-0.225,-0.2,-0.175,-0.15,-0.125,-0.1,-0.075,-0.05,-0.025,0.0,0.025,0.05,0.075,0.1,0.125,0.15,0.175,0.2,0.225,0.25,0.275,0.3,0.325,0.35,0.375,0.4,0.425,0.45,0.475,0.5,0.525,0.55,0.575,0.6,0.625,0.65,0.675,0.7,0.725,0.75,0.775,0.8,0.825,0.85,0.875,0.9,0.925,0.95,0.975,1.0,1.025,1.05,1.075,1.1,1.125,1.15,1.175,1.2,1.225,1.25,1.275,1.3,1.325,1.35,1.375,1.4,1.425,1.45,1.475,1.5,1.525,1.55,1.575,1.6,1.625,1.65,1.675,1.7,1.725,1.75,1.775,1.8,1.825,1.85,1.875,1.9,1.925,1.95,1.975,2.0,2.025,2.05,2.075,2.1,2.125,2.15,2.175,2.2,2.225,2.25,2.275,2.3,2.325,2.35,2.375,2.4,2.425,2.45,2.475,2.5,2.525,2.575,2.625,2.675,2.725,2.775,2.825,2.875,2.925,2.975,3.025,3.075,3.125,3.175,3.225,3.275,3.325,3.375,3.425,3.475,3.525,3.575,3.625,3.675,3.725,3.775,3.825,3.875,3.925,3.975,4.025,4.075,4.125,4.175,4.225,4.275,4.325,4.375,4.425,4.475,4.525,4.575,4.625,4.675,4.725,4.775,4.825,4.875,4.925,4.975,5.025,5.075,5.125,5.175,5.225,5.275,5.325,5.375,5.425,5.475,5.525,5.575,5.625,5.675,5.725,5.775,5.825,5.875,5.925,5.975,6.025,6.075,6.125,6.175,6.225,6.275,6.325,6.375,6.425,6.475,6.525,6.575,6.625,6.675,6.725,6.775,6.825,6.875,6.925,6.975,7.025,7.075,7.125,7.175,7.225,7.275,7.325,7.375,7.425,7.475,7.525,7.575,7.625,7.675,7.725,7.775,7.825,7.875,7.925,7.975,8.025,8.075,8.125,8.175,8.225,8.275,8.325,8.375,8.425,8.475,8.525,8.575,8.625,8.675,8.725,8.775,8.825,8.875,8.925,8.975,9.025,9.075,9.125,9.175,9.225,9.275,9.325,9.375,9.425,9.475,9.5 ]
#NZATTOP     = 169;
#ZATTOP      = [ 0, -1.133, -1.195, -1.06, -1.000, -0.975, -0.950, -0.925, -0.900, -0.875, -0.850, -0.825, -0.800, -0.775, -0.750, -0.725, -0.700, -0.675, -0.650, -0.625, -0.600, -0.575, -0.550, -0.525, -0.500, -0.475, -0.450, -0.425, -0.400, -0.375, -0.350, -0.325, -0.300, -0.275, -0.250, -0.225, -0.200, -0.175, -0.150, -0.125, -0.100, -0.075, -0.050, -.025,  0.025, 0.050, 0.075, 0.100, 0.125, 0.150, 0.175, 0.200, 0.225, 0.250, 0.275, 0.300, 0.325, 0.350, 0.375, 0.400, 0.425, 0.450, 0.475, 0.500, 0.525, 0.550, 0.575, 0.600, 0.625, 0.650, 0.675, 0.700, 0.725, 0.750, 0.775, 0.800, 0.825, 0.850, 0.875, 0.900, 0.925, 0.950, 0.975, 1.000, 1.025, 1.050, 1.075, 1.100, 1.125, 1.150, 1.175, 1.200, 1.225, 1.250, 1.275, 1.300, 1.325, 1.350, 1.375, 1.400, 1.425, 1.450, 1.475, 1.500, 1.525, 1.550, 1.575, 1.600, 1.625, 1.650, 1.675, 1.700, 1.725, 1.750, 1.775, 1.800, 1.825, 1.850, 1.875, 1.900, 1.925, 1.950, 1.975, 2.000, 2.025, 2.050, 2.075, 2.100, 2.125, 2.18, 2.315, 2.45, 2.585, 2.72, 2.855, 2.9, 3.125, 3.26, 3.395, 3.53, 3.665, 3.8, 3.935, 4.07, 4.205, 4.34, 4.475, 4.61, 4.745, 4.88, 5.0, 5.15, 5.3, 5.45, 5.6, 5.75, 5.9, 6.05, 6.20, 6.35, 6.50, 6.65, 6.9, 7.2, 7.5, 7.8, 8.2, 8.5, 9.0 ] ;

#z values for the atomic PES at all other sites
NZAT         = 161
ZAT          = [ -2.0,-1.95,-1.9,-1.85,-1.8,-1.75,-1.7,-1.65,-1.6,-1.55,-1.5,-1.45,-1.4,-1.35,-1.3,-1.25,-1.2,-1.15,-1.1,-1.05,-1.0,-0.95,-0.9,-0.85,-0.8,-0.75,-0.7,-0.65,-0.6,-0.55,-0.5,-0.45,-0.4,-0.35,-0.3,-0.25,-0.2,-0.15,-0.1,-0.05,0.0,0.05,0.1,0.15,0.2,0.25,0.3,0.35,0.4,0.45,0.5,0.55,0.6,0.65,0.7,0.75,0.8,0.85,0.9,0.95,1.0,1.05,1.1,1.15,1.2,1.25,1.3,1.35,1.4,1.45,1.5,1.55,1.6,1.65,1.7,1.75,1.8,1.85,1.9,1.95,2.0,2.05,2.1,2.15,2.2,2.25,2.3,2.35,2.4,2.45,2.5,2.6,2.7,2.8,2.9,3.0,3.1,3.2,3.3,3.4,3.5,3.6,3.7,3.8,3.9,4.0,4.1,4.2,4.3,4.4,4.5,4.6,4.7,4.8,4.9,5.0,5.1,5.2,5.3,5.4,5.5,5.6,5.7,5.8,5.9,6.0,6.1,6.2,6.3,6.4,6.5,6.6,6.7,6.8,6.9,7.0,7.1,7.2,7.3,7.4,7.5,7.6,7.7,7.8,7.9,8.0,8.1,8.2,8.3,8.4,8.5,8.6,8.7,8.8,8.9,9.0,9.1,9.2,9.3,9.4,9.5 ]
#NZAT        = 73;
#ZAT         = [ -1.133, -1.195, -1.06, -0.925, -0.79, -0.655, -0.52, -0.385, -0.29, -0.25, -0.155, -0.115, -0.1, 0.0, 0.1, 0.115, 0.155, 0.25, 0.29, 0.385, 0.425, 0.56, 0.695, 0.83, 0.965, 1.1, 1.235, 1.37, 1.505, 1.64, 1.775, 1.91, 2.045, 2.18, 2.315, 2.45, 2.585, 2.72, 2.855, 2.9, 3.125, 3.26, 3.395, 3.53, 3.665, 3.8, 3.935, 4.07, 4.205, 4.34, 4.475, 4.61, 4.745, 4.88, 5.0, 5.15, 5.3, 5.45, 5.6, 5.75, 5.9, 6.05, 6.20, 6.35, 6.50, 6.65, 6.9, 7.2, 7.5, 7.8, 8.2, 8.5, 9.0 ]

#R values for the 6D pes and GASPHASE
NR         = 14;
R          = [ 0.4, 0.5, 0.6, 0.65, 0.7, 0.746146, 0.8, 0.85, 1.0, 1.25, 1.5, 1.75, 2.0, 2.3 ];
Req        = 0.746146  #PBEa57



#-------------SUBMIT LOOP
COUNT = 0

#Atom 3D at TOP site
print 
locAT = 0;
for z in range(0,NZATTOP):

        print "Atomic 3D now at iteration:"
        Ratom = 0.0
        #folder name we are going to give to job_specifics together with functional
        foldername = "AT2site{0}z{1}".format(locAT,z)
        print "functional= ", functional, " locAT= ", locAT, " location= ", locationAT[locAT], " z= ", z, " Z= ", ZATTOP[z], " foldername= ", foldername
        #CREATE A POSCAR FILE
        create_poscar_file_AT(locationAT[locAT], ZATTOP[z], Ratom)

        #now check how full the Q is
        #check_Q(MAX_NUM_RUNNING_JOB)
	check_Q(MAX_NUM_RUNNING_JOB, CURRENT_DIRECTORY, Client, functional)

        #make job
        JOB = Client.SubmitJob(
        Application     = "vasp535",
        TargetResources = "mark@erc2.wks.gorlaeus.net,mark@erc1.wks.gorlaeus.net,mark@octo.wks.gorlaeus.net",
        FileList        = [ "./STANDARD/INCAR", "./STANDARD/POTCAR", "./POSCAR", "./STANDARD/KPOINTS", "./STANDARD/vdw_kernel.bindat" ],
        JobSpecifics    = "<functional> {0} </functional> <foldername> {1} </foldername> <walltime> {2} </walltime> <mem> {3} </mem> <project> {4} </project> <Queue> {5} </Queue>".format(functional, foldername, maxwalltime, maxram, project, Queue) )

        COUNT = COUNT + 1;
        print " Number of Jobs submitted ", COUNT
        
        #check for and download finished jobs
	#now redundant --> retrieval done within check Q
        #check_finished(CURRENT_DIRECTORY, Client, functional )

        #write LOG_AT
        fout_file = open("LOG_AT_file", "w");
        fout_file.write("%d %d" %(locAT, z));
        fout_file.close();
#------------------------------------------------------------------------------------------------------------------

#Atom 3D rest
print 
for locAT in range(1,10):
	print
	for z in range(0,NZAT):
		print "Atomic 3D --> now at iteration:"
		Ratom = 0.0
		#folder name we are going to give to job_specifics together with functional
		foldername = "AT2site{0}z{1}".format(locAT,z)
		print "functional= ", functional, " locAT= ", locAT, " location= ", locationAT[locAT], " z= ", z, " Z= ", ZAT[z], " foldername= ", foldername
		#CREATE A POSCAR FILE
		create_poscar_file_AT(locationAT[locAT], ZAT[z], Ratom)

	        #now check how full the Q is
	        #check_Q(MAX_NUM_RUNNING_JOB)
		check_Q(MAX_NUM_RUNNING_JOB, CURRENT_DIRECTORY, Client, functional)

  		#write LOG_AT
		fout_file = open("LOG_AT_file", "w");
		fout_file.write("%d %d" %(locAT, z));
		fout_file.close();

	        #make job
        	JOB = Client.SubmitJob(
	        Application     = "vasp535",
        	TargetResources = "mark@erc2.wks.gorlaeus.net,mark@erc1.wks.gorlaeus.net,mark@octo.wks.gorlaeus.net",
	        FileList        = [ "./STANDARD/INCAR", "./STANDARD/POTCAR", "./POSCAR", "./STANDARD/KPOINTS", "./STANDARD/vdw_kernel.bindat" ],
        	JobSpecifics    = "<functional> {0} </functional> <foldername> {1} </foldername> <walltime> {2} </walltime> <mem> {3} </mem> <project> {4} </project> <Queue> {5} </Queue>".format(functional, foldername, maxwalltime, maxram, project, Queue) )

        	COUNT = COUNT + 1;
	        print " Number of Jobs submitted ", COUNT
        
        	#check for and download finished jobs
		#now redundant --> retrieval done within check Q
	        #check_finished(CURRENT_DIRECTORY, Client, functional )
#------------------------------------------------------------------------------------------------------------------


#6D molecule PES
print
for loc in range(0,29):
	print
	for z in range(0,NZ6D):
		print
		for r in range(0,NR):

			print "MOLECULE 6D PES --> now at iteration:" 
			foldername = "site{0}z{1}r{2}".format(loc,z,r)
			print "functional= ", functional, " loc= ", loc, " location= ", location[loc], " z= ", z, " Z= ", Z6D[z], " r= ", r , " R= ", R[r], " foldername= ", foldername
			#CREATE A POSCAR FILE
			create_poscar_file(location[loc], Z6D[z], R[r])

		        #now check how full the Q is
        		#check_Q(MAX_NUM_RUNNING_JOB)
			check_Q(MAX_NUM_RUNNING_JOB, CURRENT_DIRECTORY, Client, functional)

			#write LOG_MOOL
			fout_file = open("LOG_MOL_file", "w");
			fout_file.write("%d %d %d" %(loc, z, r));
                        fout_file.close();

	        	#make job
	        	JOB = Client.SubmitJob(
		        Application     = "vasp535",
        		TargetResources = "mark@erc2.wks.gorlaeus.net,mark@erc1.wks.gorlaeus.net,mark@octo.wks.gorlaeus.net",
		        FileList        = [ "./STANDARD/INCAR", "./STANDARD/POTCAR", "./POSCAR", "./STANDARD/KPOINTS", "./STANDARD/vdw_kernel.bindat" ],
        		JobSpecifics    = "<functional> {0} </functional> <foldername> {1} </foldername> <walltime> {2} </walltime> <mem> {3} </mem> <project> {4} </project> <Queue> {5} </Queue>".format(functional, foldername, maxwalltime, maxram, project, Queue) )

	        	COUNT = COUNT + 1;
	        	print " Number of Jobs submitted ", COUNT
        
	        	#check for and download finished jobs
			#now redundant --> retrieval done within check Q
        		#check_finished(CURRENT_DIRECTORY, Client, functional )
#------------------------------------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------------------------
# 		END SUBMIT LOOP

print
print "entering retrieval loop"
CONTINUE_VAR = 1 ;
while CONTINUE_VAR == 1 :
  check_finished(CURRENT_DIRECTORY, Client, functional )
  print "Going to sleep ......"
  time.sleep(1800);     

